VERSION 5.00
Begin {C62A69F0-16DC-11CE-9E98-00AA00574A4F} Isolieren_Userform 
   Caption         =   "Isolieren_Userform"
   ClientHeight    =   2985
   ClientLeft      =   45
   ClientTop       =   435
   ClientWidth     =   4710
   OleObjectBlob   =   "Isolieren_Userform.frx":0000
   StartUpPosition =   1  'Fenstermitte
End
Attribute VB_Name = "Isolieren_Userform"
Attribute VB_GlobalNameSpace = False
Attribute VB_Creatable = False
Attribute VB_PredeclaredId = True
Attribute VB_Exposed = False
Option Explicit

'API-Funktionen deklarieren
Private Declare Sub CoTaskMemFree Lib "ole32.dll" (ByVal hMem As Long)
Private Declare Function lstrcat Lib "kernel32" Alias "lstrcatA" (ByVal lpString1 As String, ByVal lpString2 As String) As Long
Private Declare Function SHBrowseForFolder Lib "shell32" (lpbi As BrowseInfo) As Long
Private Declare Function SHGetPathFromIDList Lib "shell32" (ByVal pidList As Long, ByVal lpBuffer As String) As Long
Private Declare Function FindWindow Lib "user32" Alias "FindWindowA" (ByVal lpClassName As Any, ByVal lpWindowName As Any) As Long

'Benutzerdefinierte Variablen deklarieren
Private Type BrowseInfo
    hWndOwner As Long
    pIDLRoot As Long
    pszDisplayName As Long
    lpszTitle As Long
    ulFlags As Long
    lpfnCallback As Long
    lParam As Long
    iImage As Long
End Type

'Dialogtitel festlegen
Const DLG_TITEL As String = "Attachments isolieren"

'Globale Variablen deklarieren
Dim oAktOrdner As MAPIFolder    'Aktuell markierter Outlook-Ordner
Dim sBasisDir As String         'Basis-Zielverzeichnis
Dim lZhler As Long             'Zhlvariable

Private Sub UserForm_Initialize()
    Me.Caption = DLG_TITEL

    'Verweis auf aktuell markierten Ordner besorgen
    Set oAktOrdner = Application.ActiveExplorer.CurrentFolder
    'Wenn kein Ordner markiert...
    If oAktOrdner Is Nothing Then
        'Fehlermeldung anzeigen
        MsgBox "Bitte aktivieren Sie die Ordnerliste im Men 'Ansicht'," & vbCr & "und markieren Sie einen Outlook-Ordner.", vbCritical, DLG_TITEL
        'Dialog beenden
        End
    'Wenn Ordner markiert...
    Else
        'Name in TextBox1 bernehmen
        TextBox1.Text = oAktOrdner.Name
    End If

    'Zuletzt gewhltes Zielverzeichnis aus Registry in TextBox2 einlesen
    TextBox2.Text = GetSetting(DLG_TITEL, "Einstellungen", "Zielverzeichnis", "")
End Sub

Private Sub CommandButton1_Click()
    Dim sZielDir As String
    
    'Dialog zur Auswahl des Zielverzeichnisses aufrufen
    sZielDir = OrdnerWhlen("Whlen Sie das Zielverzeichnis:")
    'Wenn Zielverzeichnis angegeben...
    If sZielDir > "" Then
        'Zielverzeichnis in TextBox2 bernehmen
        TextBox2.Text = sZielDir
    End If
End Sub

Private Sub CommandButton2_Click()
    'Wenn TextBox2 kein oder kein gltiges Verzeichnis enthlt...
    If TextBox2.Text = "" Or Dir(IIf(Right(TextBox2.Text, 1) <> "\", TextBox2.Text & "\nul", TextBox2.Text & "nul")) = "" Then
        'Fehlermeldung ausgeben
        MsgBox "Bitte whlen Sie ein gltiges Zielverzeichnis.", vbInformation, DLG_TITEL
        'Eingabefokus auf TextBox2 setzen
        TextBox2.SetFocus
        'Prozedur verlassen
        Exit Sub
    'Wenn TextBox2 gltiges Verzeichnis enthlt...
    Else
        'Textboxinhalt als Basisverzeichnis bernehmen
        sBasisDir = TextBox2.Text
    End If
    
    'Alle Mailanhnge des gewhlten Outlook-Ordners isolieren
    Call Isolieren(oAktOrdner)
    'Wenn CheckBox1 eingeschaltet ist...
    If CheckBox1.Value = True Then
        'Mailanhnge aus Unterordnern des gewhlten Outlook-Ordners isolieren
        Call UnterordnerIsolieren(oAktOrdner)
    End If
    
    'Erfolgsmeldung anzeigen
    MsgBox CStr(lZhler) & " Attachments isoliert.", vbInformation, DLG_TITEL
    
    'Zielverzeichnis in Registry speichern
    SaveSetting DLG_TITEL, "Einstellungen", "Zielverzeichnis", TextBox2.Text
    
    'Userform entladen
    Unload Me
End Sub

Private Sub CommandButton3_Click()
    'Userform entladen
    Unload Me
End Sub

Private Sub Isolieren(oOrdner As MAPIFolder)
    Dim i As Integer
    Dim oElement As Object
    Dim sZielDir As String
    Dim j As Integer
    Dim oAnhang As Attachment
    Dim sLink As String

    'Fehlerverfolgung aus
    On Error Resume Next
        
    'Alle Elemente des Outlook-Ordners behandeln
    For i = 1 To oOrdner.Items.Count
        'Verweis auf aktuelles Element holen
        Set oElement = oOrdner.Items(i)
        'Wenn Element Anhnge besitzt...
        If oElement.Attachments.Count > 0 Then
            'Namen des Zielverzeichnisses aus Basisverzeichnis und eindeutiger Element-ID bilden
            sZielDir = IIf(Right(sBasisDir, 1) <> "\", sBasisDir & "\" & oElement.EntryID, sBasisDir & oElement.EntryID)
            'Zielverzeichnis anlegen
            MkDir sZielDir
            'Wenn Zielverzeichnis erfolgreich angelegt...
            If Dir(sZielDir & "\nul") > "" Then
                'Alle Anhnge behandeln
                For j = oElement.Attachments.Count To 1 Step -1
                    'Verweis auf aktuellen Anhang holen
                    Set oAnhang = oElement.Attachments(j)
                    With oAnhang
                        'Anhang als Datei im Zielverzeichnis speichern
                        .SaveAsFile sZielDir & "\" & .FileName
                        'Anhang aus Element lschen
                        .Delete
                    End With
                Next
                
                'Hyperlink auf Zielverzeichnis bilden
                sLink = "file://" & Replace(sZielDir, " ", "%20")
                With oElement
                    'Hyperlink ans Ende des Elementtextes hngen
                    .Body = .Body & vbCr & vbCr & "Die Attachments dieser Mail wurden in folgendes Verzeichnis ausgelagert:" & vbCr & sLink
                    'Element speichern
                    .Save
                    'Zhlvariable erhhen
                    lZhler = lZhler + 1
                End With
            End If
        End If
    Next
End Sub

Private Sub UnterordnerIsolieren(oOrdner As MAPIFolder)
    Dim oUnterordner As MAPIFolder

    'Alle Unterordner des Ordners behandeln
    For Each oUnterordner In oOrdner.Folders
        'Mail-Anhnge des jeweiligen Unterordners Isolieren
        Call Isolieren(oUnterordner)
        'Diese Prozedur rekursiv fr alle Unterordner des Unterordners aufrufen
        Call UnterordnerIsolieren(oUnterordner)
    Next
End Sub

Private Function OrdnerWhlen(stTitel As String) As String
    Dim iNull As Integer
    Dim lpIDList As Long
    Dim lResult As Long
    Dim sPath As String
    Dim udtBI As BrowseInfo

    With udtBI
        'Fenstereigner ist aktuelle Userform
        .hWndOwner = FindWindow(0&, CStr(Me.Caption))
        'Dialogtitel festlegen
        .lpszTitle = lstrcat(stTitel, "")
        'Nur Verzeichnisse zurckliefern
        .ulFlags = 1
    End With

    'Dialog anzeigen
    lpIDList = SHBrowseForFolder(udtBI)
    'Wenn 'OK' gewhlt...
    If lpIDList Then
        'Puffervariable fr Pfad vorbereiten
        sPath = String$(260, 0)
        'Pfad holen
        SHGetPathFromIDList lpIDList, sPath
        'Speicherblock freigeben
        CoTaskMemFree lpIDList
        'Nach abschlieendem Nullzeichen suchen
        iNull = InStr(sPath, vbNullChar)
        'Wenn Nullzeichen gefunden...
        If iNull Then
            'Pfad isolieren und zurckgeben
            OrdnerWhlen = Left$(sPath, iNull - 1)
        End If
    End If
End Function
